// Generated by CoffeeScript 1.12.7
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

ez5.Barcode = (function(superClass) {
  extend(Barcode, superClass);

  Barcode.TYPE_QR = "QR code";

  Barcode.TYPE_BAR = "Barcode";

  Barcode.DEFAULT_BARCODE_TYPE = "CODE128";

  Barcode.prototype.initOpts = function() {
    Barcode.__super__.initOpts.call(this);
    return this.addOpts({
      type: {
        check: [ez5.Barcode.TYPE_BAR, ez5.Barcode.TYPE_QR],
        "default": ez5.Barcode.TYPE_BAR
      },
      barcode_type: {
        check: String,
        "default": ez5.Barcode.DEFAULT_BARCODE_TYPE
      },
      mode: {
        check: String
      }
    });
  };

  function Barcode(opts) {
    Barcode.__super__.constructor.call(this, opts);
    this.registerDOMElement(CUI.dom.div());
    this.__ratio = CUI.dom.div("cui-barcode-ratio");
    CUI.dom.append(this.DOM, this.__ratio);
    return this;
  }

  Barcode.prototype.render = function(data, convertToImage) {
    var canvas, element, img, isQR, url;
    if (convertToImage == null) {
      convertToImage = false;
    }
    isQR = this._type === ez5.Barcode.TYPE_QR;
    if (isQR) {
      this.addClass("cui-barcode--matrix");
    }
    if (!data || !(CUI.util.isString(data) || CUI.util.isNumber(data))) {
      if (this._mode === "editor") {
        this.__replaceWithLabel("barcode.label.empty-data." + (this.__getLocaType()));
        return this;
      }
      CUI.dom.empty(this.__ratio);
      return this;
    }
    if (isQR) {
      data = data.toString();
      if (data.length >= 1056) {
        this.__replaceWithLabel("barcode.label.qr-data-too-long");
        return this;
      }
      element = CUI.dom.div();
      new QRCode(element, data);
      img = CUI.dom.findElement(element, "img");
      CUI.dom.remove(img);
    } else {
      element = CUI.dom.$element("canvas");
      try {
        JsBarcode(element, data, {
          format: this._barcode_type
        });
      } catch (error) {
        this.__replaceWithLabel("barcode.label.wrong-data." + (this.__getLocaType()));
        return this;
      }
    }
    if (convertToImage) {
      canvas = CUI.dom.findElement(element, "canvas");
      url = canvas.toDataURL();
      element = CUI.dom.element("img", {
        src: url
      });
    }
    CUI.dom.replace(this.__ratio, element);
    return this;
  };

  Barcode.prototype.__replaceWithLabel = function(locaKey) {
    var label;
    label = new CUI.Label({
      text: $$(locaKey),
      centered: true,
      appearance: "secondary",
      size: "mini",
      multiline: true
    });
    CUI.dom.replace(this.__ratio, label);
  };

  Barcode.prototype.__getLocaType = function() {
    return this._type.replace(/\s/g, "_").toLowerCase();
  };

  return Barcode;

})(CUI.DOMElement);
